import java.util.concurrent.*;
import java.util.concurrent.locks.ReentrantLock;

public class ThreadDemo {
    static ReentrantLock r = new ReentrantLock(true);
    static Semaphore sem = new Semaphore(2,true);
    public static void main(String[] args) {
        /*new Thread(()->print('A')).start();
        new Thread(()->print('B')).start();
        new Thread(()->print('C')).start();*/
        Object o = new Object();
        new Thread(()->printV2('A')).start();
        new Thread(()->printV2('B')).start();
        new Thread(()->printV2('C')).start();

        ThreadPoolExecutor t;
        Executors executors;
        ExecutorService service;
        BlockingQueue<String> queue = new ArrayBlockingQueue(4);
    }
    static synchronized void print(char c){
        for (int i = 0; i<100; i++)
            System.out.print(c);
    }
    static void printV2(char c){
        try {
            sem.acquire();
            for (int i = 0; i<100; i++)
                System.out.print(c);
            sem.release();
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }
    static void otherMethod(){
        int i = 4;
        synchronized (ThreadDemo.class){
            System.out.println(i);
        }
    }
    static void safeMethod(){
        //some code
        r.lock();
        //synchronized code here
        r.unlock();
    }
}
